var Session = /** @class */ (function () {
    function Session(e) {
        this.session = e.session;
        this.callId = e.request.getHeader('X-Webitel-Uuid');
        this.incoming = e.session.direction === 'incoming';
        this.instanceId = e.request.getHeader('X-Webitel-Sock-Id');
    }
    Object.defineProperty(Session.prototype, "id", {
        get: function () {
            return this.session.id;
        },
        enumerable: true,
        configurable: true
    });
    Session.prototype.getLocalMedia = function () {
        if (this.session.connection) {
            var local = this.session.connection.getLocalStreams();
            if (local.length) {
                return local;
            }
        }
        return [];
    };
    Session.prototype.getPeerMedia = function () {
        if (this.session.connection) {
            var peer = this.session.connection.getRemoteStreams();
            if (peer.length) {
                return peer;
            }
        }
        return [];
    };
    Session.prototype.answer = function (s) {
        var _this = this;
        return new Promise(function () {
            _this.session.answer(s);
        });
    };
    return Session;
}());
export { Session };
//# sourceMappingURL=session.js.map